Program Crosswords;
uses dos,crt;

Type diconoeud=^dn;
     dn=record
        mot,defin:string;
        motinf,motsup:diconoeud;
     end;

Type versnoeud=^Noeud;
     Noeud=record
        x,y,l:integer;
        o:char;
        sup,inf:versnoeud;
     end;

Type pecart=^enreg;
     enreg=record
        x:integer;
        y:integer;
        l:integer;
        o:char;
        mot:string;
        defin:string;
        suiv:pecart;
     end;

Type pmot=^elemot;
     elemot=record
        mot:string;
        defin:string;
        suiv:pmot;
     end;

Type grillemot=array[1..30,1..30] of string;

Type vecteurmot=array[1..30] of string;

Type pdepend=^depend;
     depend=record
        ppx:integer;
        ppy:integer;
        x:integer;
        y:integer;
        l:integer;
        o:char;
        vmot:vecteurmot;
        mot:string;
        statut:boolean;
        suiv:pdepend;
     end;

Type statdep=record
        mot:string;
        defin:string;
        ndep:integer;
        ndepexis:integer;
     end;


type element= record
               lettre:char;      (* a..z   *)
               direction:char;   (* h ou v *)
               definitionv:string;   (*defv et defh car sinon peut avoir *)
               definitionh:string;      (* deux defs sur une case*)
              end;
type coordonnee = record
                 x:integer;
                 y:integer;
                 end;

type matrice= array[1..50,1..50] of element;


type ptr=^ptrcase;
     ptrcase=record
      coord:coordonnee;
      suivant:ptr;
     end;
type vecteurdef=array[1..78] of char;

var m,mjeu:matrice;
    lettre,Dir:char;
    nbrecasenoir, lignemax,colonnemax,fichier,continue_entree_mot: integer;
    p,debut,mp,mdebut:ptr;
    reponse,minutes_pr_le_jeu:integer;
    definition:vecteurdef;
    lignes,colonnes,i,j,coordX,coordY,choix:integer;
    motpropose,def:string;
    save1,save2,save3,save4,save5:text;
    dictio,sortie:text;
    heurededepart,mindebut,heure,min,sec,cent:word;
(*---------variables pour les procdures motus et if_then et if_then2----*)
type pointeur=^cel;
       cel=record
          lettre:string;
          emplacementlettre:integer;
          suivant:pointeur;
         end;

var nbre_lettres,empl_ds_mot, longueurmot,ii_motus,nbremotecrit:integer;
     lettre_mot,motlut,mot:string;
     debutmotus,pmotus:pointeur;
     entree:text;
     debutpc:ptr;


(***************************************************************************)
Function DictioVide(var dictionnaire:text):boolean;
Begin
        if eof(dictionnaire) then (*si dictionnaire vide alors*)
        begin                     (*message erreur et rsultat=True*)
                writeln('***ERREUR***');
                writeln('Le dictionnaire est vide');
                writeln('Impossible de creer une grille');
                DictioVide:=True;
        end
        else DictioVide:=False;
End;

(***************************************************************************)
Procedure DicoArbre(mot,defin:string;var p:diconoeud);
Begin
        if p=NIL then
        begin
                new(p);
                p^.mot:=mot;
                p^.defin:=defin;
                p^.motsup:=NIL;
                p^.motinf:=NIL;
        end
        else if length(mot)>length(p^.mot) then DicoArbre(mot,defin,p^.motsup)
           else if length(mot)<length(p^.mot) then DicoArbre(mot,defin,p^.motinf)
                else
                begin
                    if mot<p^.mot then DicoArbre(mot,defin,p^.motsup)
                    else if mot>p^.mot then DicoArbre(mot,defin,p^.motinf)
                end;
End;

(****************************************************************************)
Procedure DicoListe(p:diconoeud;var pm,debutpm:pmot);
Begin
        if p^.motsup<>NIL then DicoListe(p^.motsup,pm,debutpm);
        if debutpm=NIL then
        begin
                new(debutpm);
                pm:=debutpm;
                pm^.mot:=p^.mot;
                pm^.defin:=p^.defin;
        end
        else
        begin
                new(pm^.suiv);
                pm:=pm^.suiv;
                pm^.mot:=p^.mot;
                pm^.defin:=p^.defin;
                pm^.suiv:=NIL;
        end;
        if p^.motinf<>NIL then DicoListe(p^.motinf,pm,debutpm);
End;

(******************************************************************************)
Procedure VerifDoubComp(var compatible:boolean;
                        mot:string;
                        debutpmcomp:pmot;
                        debutpg:pecart);

Var pmcompdoubl:pmot;
    pgdoubl:pecart;

Begin
        (*verif. doubl. parmi les mots ds grille*)
        pgdoubl:=debutpg;
        while pgdoubl <> NIL do
        begin
                if pgdoubl^.mot = mot
                then compatible:=FALSE;
                pgdoubl:=pgdoubl^.suiv;
        end;


        (*verif. doubl. parmi les mots compatibles*)
        if debutpmcomp <> NIL then
        begin
                pmcompdoubl:=debutpmcomp;
                while pmcompdoubl <> NIL do
                begin
                        if pmcompdoubl^.mot = mot
                        then compatible:=FALSE;
                        pmcompdoubl:=pmcompdoubl^.suiv;
                end;
        end;
End;

(***************************************************************************)
Procedure VerifDoubDep(var compatible:boolean;
                       mot,motcomp:string;
                       debutpdep:pdepend;
                       debutpg:pecart);

Var pdep:pdepend;
    pgdoubl:pecart;

Begin
        (*un mot ne peut pas etre dependant de lui-meme*)
        if motcomp = mot then compatible:=FALSE;

        (*un mot precedemment mis dans la grille ne
        peut pas etre une dependance*)
        pgdoubl:=debutpg;
        while pgdoubl <> NIL do
        begin
                if pgdoubl^.mot = mot
                then compatible:=FALSE;
                pgdoubl:=pgdoubl^.suiv;
        end;

        (*un mot ne peut pas servir de dependance
        2 fois*)
        pdep:=debutpdep;
        while pdep <> NIL do
        begin
                if pdep^.mot = mot
                then compatible:=FALSE;
                pdep:=pdep^.suiv;
        end;
End;

(***************************************************************************)
Function MotsCompatibles(vecmot:vecteurmot;debutpm:pmot;debutpg,pg:pecart):pmot;

Var i:integer;
    compatible:boolean;
    pm,pmcomp,debutpmcomp:pmot;

Begin
        pm:=debutpm;
        debutpmcomp:=NIL;
        pmcomp:=NIL;
        MotsCompatibles:=NIL;

        while pm <> NIL do
        begin
                compatible:=FALSE;
                if length(pm^.mot) = pg^.l then
                begin
                        for i:=1 to pg^.l do
                        begin
                                if vecmot[i] <> '*' then
                                if copy(pm^.mot,i,1) = vecmot[i]
                                then compatible:=TRUE
                                else
                                begin
                                        compatible:=FALSE;
                                        break;
                                end
                                else compatible:=TRUE;
                        end;

                        (*si mot compatible alors verifier doublons*)
                        if compatible=TRUE then VerifDoubComp(compatible,pm^.mot,debutpmcomp,debutpg);

                        (*si le mot est toujours compatible alors mettre
                        le mot dans la liste de mots compatibles*)
                        if compatible = TRUE then
                        begin
                                if debutpmcomp = NIL then
                                begin
                                        new(debutpmcomp);
                                        MotsCompatibles:=debutpmcomp;
                                        pmcomp:=debutpmcomp;
                                        pmcomp^.mot:=pm^.mot;
                                        pmcomp^.defin:=pm^.defin;
                                        pmcomp^.suiv:=NIL;
                                end
                                else
                                begin
                                        new(pmcomp^.suiv);
                                        pmcomp:=pmcomp^.suiv;
                                        pmcomp^.mot:=pm^.mot;
                                        pmcomp^.defin:=pm^.defin;
                                        pmcomp^.suiv:=NIL;
                                end;
                        end;
                end
                else if length(pm^.mot) < pg^.l then break;
                pm:=pm^.suiv;
        end;
End;

(***************************************************************************)
Procedure CreaLInter(ptpassx,ptpassy:integer;orient:char;var debutpdep,pdep:pdepend);

Begin
        if debutpdep = NIL then
        begin
                new(debutpdep);
                pdep:=debutpdep;
                pdep^.ppx:=ptpassx;
                pdep^.ppy:=ptpassy;
                pdep^.x:=0;
                pdep^.y:=0;
                pdep^.l:=0;
                pdep^.o:=orient;
                pdep^.statut:=FALSE;
                pdep^.suiv:=NIL;
        end
        else
        begin
                new(pdep^.suiv);
                pdep:=pdep^.suiv;
                pdep^.ppx:=ptpassx;
                pdep^.ppy:=ptpassy;
                pdep^.x:=0;
                pdep^.y:=0;
                pdep^.l:=0;
                pdep^.o:=orient;
                pdep^.statut:=FALSE;
                pdep^.suiv:=NIL;
        end;
End;

(***************************************************************************)
Function LInter(orient:char;long:integer;pg:pecart):pdepend;

Var i:integer;
    pdep,debutpdep:pdepend;

Begin;
        debutpdep:=NIL;
        if orient = 'h' then
                for i:=1 to long do CreaLInter(pg^.x+i-1,pg^.y,'h',debutpdep,pdep)
        else if orient = 'v' then
                for i:=1 to long do CreaLInter(pg^.x,pg^.y+i-1,'v',debutpdep,pdep);
        LInter:=debutpdep;
End;

(***************************************************************************)
Procedure DeterSpecs(col,lig,lmot:integer;
                     orient:char;
                     var matrice:grillemot;
                     var vecteur:vecteurmot);
Var i:integer;
Begin
        for i:=1 to 30 do vecteur[i]:=chr(32);
        if orient='h' then
        begin
                for i:=1 to lmot do
                begin
                        if matrice[lig,col] <> chr(32)
                        then vecteur[i]:=matrice[lig,col]
                        else vecteur[i]:='*';
                        col:=col+1;
                end;
        end
        else if orient='v' then
        begin
                for i:=1 to lmot do
                begin
                        if matrice[lig,col]<>chr(32)
                        then vecteur[i]:=matrice[lig,col]
                        else vecteur[i]:='*';
                        lig:=lig+1;
                end;
        end;
End;

(****************************************************************************)
Procedure DansGrille(var grille:grillemot;
                     lig,col,lmot:integer;
                     mot:string;
                     orient:char);
Var i:integer;
Begin
        if orient='h' then          (*si orientation horizontale*)
        begin
                for i:=1 to lmot do
                begin
                        grille[lig,col]:=copy(mot,i,1);
                        col:=col+1;
                end;
        end
        else if orient='v' then    (*si orientation verticale*)
        begin
                for i:=1 to lmot do
                begin
                        grille[lig,col]:=copy(mot,i,1);
                        lig:=lig+1;
                end;
        end;
End;

(***************************************************************************)
Function LMot:pmot;
Var mot,defin:string;
    entree:text;
    p:diconoeud;
    debutpm,pm:pmot;

Begin
        assign(entree,'dictionnaire.dat');
        reset(entree);

        If DictioVide(entree) = TRUE then halt;
        p:=NIL;
        while not eof(entree) do
        begin
                readln(entree,mot);
                readln(entree,defin);
                DicoArbre(mot,defin,p);
        end;

        DicoListe(p,pm,debutpm);

        LMot:=debutpm;

        close(entree);
        End;


(***************************************************************************)
Procedure CalculEcarts(l,c:integer;
                       orientation:char;
                       passlig,condpasslig:integer;
                       var debut:pecart;
                       var nouvecart:boolean;
                       grille:grillemot;
                       var pg:pecart);
Begin
        if grille[l,c] <> chr(219) then
        begin
                if nouvecart=TRUE then
                begin
                        if debut=NIL then
                        begin
                                new(debut);
                                pg:=debut;
                                pg^.x:=c;
                                pg^.y:=l;
                                pg^.l:=1;
                                pg^.o:=orientation;
                                pg^.suiv:=NIL;
                        end
                        else inc(pg^.l);
                end
                else
                begin
                        if pg^.l>1 then
                        begin
                                new(pg^.suiv);
                                pg:=pg^.suiv;
                                pg^.suiv:=NIL;
                                pg^.x:=c;
                                pg^.y:=l;
                                pg^.l:=1;
                                pg^.o:=orientation;
                                nouvecart:=TRUE;
                        end
                        else
                        begin
                                pg^.x:=c;
                                pg^.y:=l;
                                pg^.o:=orientation;
                                nouvecart:=TRUE;
                        end;
                end;
        end
        else if debut<>NIL then nouvecart:=FALSE;

        if passlig=condpasslig then nouvecart:=FALSE;
end;

(***************************************************************************)
Function Ecarts(grille:grillemot):pecart;
Var l,c:integer;
    debuthori,debutvert,pg:pecart;
    nouvecart:boolean;
Begin
        (*calcul ecarts horizontaux-----------------------------------------*)
        debuthori:=NIL;
        nouvecart:=TRUE;
        for l:=1 to lignemax do
                for c:=1 to colonnemax do CalculEcarts(l,c,'h',c,colonnemax,debuthori,nouvecart,grille,pg);
        (*elimine dernier ecart si = 1*)
        if pg^.l=1 then
        begin
                pg:=debuthori;
                while pg<>NIL do
                begin
                        if pg^.suiv^.l=1 then pg^.suiv:=NIL;
                        pg:=pg^.suiv;
              end;
        end;

        (*calcul ecarts verticaux--------------------------------------------*)
        debutvert:=NIL;
        nouvecart:=TRUE;
        for c:=1 to colonnemax do
                for l:=1 to lignemax do CalculEcarts(l,c,'v',l,lignemax,debutvert,nouvecart,grille,pg);
        (*elimine ecarts = 1*)
        if pg^.l=1 then
        begin
                pg:=debutvert;
                while pg<>NIL do
                begin
                        if pg^.suiv^.l=1 then pg^.suiv:=NIL;
                        pg:=pg^.suiv;
              end;
        end;

        (*rattachement de la liste des ecarts verticaux  celle des horizontaux*)
        Ecarts:=debuthori;
        pg:=debuthori;
        while pg^.suiv<>NIL do pg:=pg^.suiv;
        pg^.suiv:=debutvert;
End;

(***************************************************************************)
Procedure ArbreTri(x,y,l:integer;o:char;var p:versnoeud);
Begin
        if p=NIL then
        begin
                new(p);
                p^.l:=l;
                p^.x:=x;
                p^.y:=y;
                p^.o:=o;
                p^.sup:=NIL;
                p^.inf:=NIL;
        end
        else
        begin
                if l<p^.l then ArbreTri(x,y,l,o,p^.inf)
                else if l>p^.l then ArbreTri(x,y,l,o,p^.sup)
                else if l=p^.l then
                begin
                        if x<p^.x then ArbreTri(x,y,l,o,p^.sup)
                        else if x>p^.x then ArbreTri(x,y,l,o,p^.inf)
                        else if x=p^.x then
                        begin
                                if y<p^.y then ArbreTri(x,y,l,o,p^.sup)
                                else if y>p^.y then ArbreTri(x,y,l,o,p^.inf)
                                else if y=p^.y then
                                begin
                                        if o='h' then ArbreTri(x,y,l,o,p^.sup)
                                        else if o='v' then ArbreTri(x,y,l,o,p^.inf);
                                end;
                        end;
                end;
        end;
End;

(****************************************************************************)
Procedure TriArbre(p:versnoeud;var debutpg,pg:pecart);
Begin
        if p^.sup<>NIL then TriArbre(p^.sup,debutpg,pg);
        if debutpg=NIL then
        begin
                new(debutpg);
                pg:=debutpg;
                pg^.suiv:=NIL;
                pg^.x:=p^.x;
                pg^.y:=p^.y;
                pg^.l:=p^.l;
                pg^.o:=p^.o;
        end
        else
        begin
                new(pg^.suiv);
                pg:=pg^.suiv;
                pg^.suiv:=NIL;
                pg^.x:=p^.x;
                pg^.y:=p^.y;
                pg^.l:=p^.l;
                pg^.o:=p^.o;
        end;
        if p^.inf<>NIL then TriArbre(p^.inf,debutpg,pg);
end;

(****************************************************************************)
Procedure InitGrille(var matgrille:grillemot);

Var l,c:integer;

Begin
        for l:=1 to 30 do
                for c:=1 to 30 do matgrille[l,c]:=chr(32);
End;

(****************************************************************************)
Procedure ImplementCN(debut:ptr;var matgrille:grillemot);

Var p:ptr;

Begin
        p:=debut;
        while p <> NIL do
        begin
                matgrille[p^.coord.y,p^.coord.x]:=chr(219);
                p:=p^.suivant;
        end;
End;

(****************************************************************************)
Function LEcarts(grille:grillemot):pecart;

Var parbre:versnoeud;
    debutpg,pg:pecart;

Begin
        pg:=NIL;
        debutpg:=NIL;

        (*pg pointe d'abord vers la liste non triee de nouveaux ecarts*)
        debutpg:=Ecarts(grille);

        (*ensuite on effectue le tri par arbre binaire*)
        parbre:=NIL;
        pg:=debutpg;
        while pg<>NIL do
        begin
                ArbreTri(pg^.x,pg^.y,pg^.l,pg^.o,parbre);
                pg:=pg^.suiv;
        end;

        (*et enfin, on fait pointer debutpg vers la liste triee*)
        debutpg:=NIL;
        TriArbre(parbre,debutpg,pg);
        pg:=debutpg;
        LEcarts:=debutpg;
End;

(***************************************************************************)
Procedure CompletLInter(var intmax:integer;debutpdep:pdepend;debutpg,pg:pecart);

Var i:integer;
    pdep:pdepend;
    pgdep:pecart;

Begin
        if debutpdep <> NIL then
        begin
                pdep:=debutpdep;
                while pdep <> NIL do
                begin
                        pgdep:=debutpg;
                        while pgdep <> NIL do
                        begin
                                if pg^.o <> pgdep^.o then
                                begin
                                        if pgdep^.o='v' then
                                        begin
                                                for i:=1 to pgdep^.l do
                                                begin
                                                        if (pgdep^.x = pdep^.ppx)
                                                        and (pgdep^.y+i-1 = pdep^.ppy)
                                                        then
                                                        begin
                                                                pdep^.x:=pgdep^.x;
                                                                pdep^.y:=pgdep^.y;
                                                                pdep^.l:=pgdep^.l;
                                                                pdep^.o:=pgdep^.o;
                                                                inc(intmax);
                                                                break;
                                                        end;
                                                end;
                                        end
                                        else
                                        begin
                                                for i:=1 to pgdep^.l do
                                                begin
                                                        if (pgdep^.x+i-1 = pdep^.ppx)
                                                        and (pgdep^.y = pdep^.ppy)
                                                        then
                                                        begin
                                                                pdep^.x:=pgdep^.x;
                                                                pdep^.y:=pgdep^.y;
                                                                pdep^.l:=pgdep^.l;
                                                                pdep^.o:=pgdep^.o;
                                                                inc(intmax);
                                                                break;
                                                        end;
                                                end;
                                        end;
                                end;
                                (*instruction qui interrompt la boucle une fois
                                les coordonnees de la dependence trouvees*)
                                if pdep^.x <> 0 then break;

                                pgdep:=pgdep^.suiv;
                        end;
                        pdep:=pdep^.suiv;
                end;
        end;
End;

(***************************************************************************)
Procedure InterExist(var intex:integer;debutpm:pmot;debutpdep:pdepend;pmcomp:pmot;debutpg:pecart);

Var i:integer;
    compatible:boolean;
    pm:pmot;
    pdep:pdepend;

Begin
        pdep:=debutpdep;
        while pdep <> NIL do
        begin
                pm:=debutpm;
                while pm <> NIL do
                begin
                        compatible:=FALSE;
                        if length(pm^.mot) = pdep^.l then
                        begin
                                for i:=1 to pdep^.l do
                                begin
                                        if pdep^.vmot[i] <> '*' then
                                        begin
                                                if copy(pm^.mot,i,1) = pdep^.vmot[i]
                                                then compatible:=TRUE
                                                else
                                                begin
                                                        compatible:=FALSE;
                                                        break;
                                                end;
                                        end
                                        else compatible:=TRUE;
                                end;
                                if compatible = TRUE then
                                VerifDoubDep(compatible,pm^.mot,pmcomp^.mot,debutpdep,debutpg);
                                (*si dependance existe, statut pdep = TRUE*)
                                if compatible = TRUE then
                                begin
                                        pdep^.mot:=pm^.mot;
                                        inc(intex);
                                        pdep^.statut:=TRUE;
                                        break;
                                end;
                        end
                        else if length(pm^.mot) < pdep^.l then break;
                        pm:=pm^.suiv;
                end;
                pdep:=pdep^.suiv;
        end;
End;

(****************************************************************************)
Function ConditionSortie(debutpg:pecart):boolean;

Var pg:pecart;

Begin
        ConditionSortie:=FALSE;
        pg:=debutpg;
        while pg <> NIL do
        begin
                if pg^.mot <> '' then ConditionSortie:=TRUE
                else
                begin
                        ConditionSortie:=FALSE;
                        break;
                end;
                pg:=pg^.suiv;
        end;
End;

(***************************************************************************)
Procedure CreaFSortie(debutpg:pecart);

Var sortiegrille:text;
    pg:pecart;

Begin
        assign(sortiegrille,'save1.dat');
        rewrite(sortiegrille);
        writeln(sortiegrille,lignemax,' ',colonnemax);
        pg:=debutpg;

        while pg <> NIL do
        begin
                writeln(sortiegrille, pg^.x,' ',pg^.y,' ',pg^.o,' ',pg^.mot,' ',pg^.defin);
                pg:=pg^.suiv;
        end;
        close(sortiegrille);
End;

(****************************************************************************)
Procedure AjoutCN(debutpc:ptr;pg:pecart);
Var pc:ptr;
Begin
        pc:=debutpc;
        while pc^.suivant <> NIL do pc:=pc^.suivant;
        new(pc^.suivant);
        pc:=pc^.suivant;

        pc^.suivant:=NIL;
        if pg^.o='h' then
        begin
                pc^.coord.x:=round(pg^.x+pg^.l/2);
                pc^.coord.y:=pg^.y;
        end
        else if pg^.o='v' then
        begin
                pc^.coord.x:=pg^.x;
                pc^.coord.y:=round(pg^.y+pg^.l/2);
        end;
End;

(***************************************************************************)
Procedure ImplementGrille;

Var l,c,compmax:integer;
    grille,grilleprov:grillemot;
    grilleremplie:boolean;
    motdep,motdepmax:statdep;
    vecmot:vecteurmot;
    debutpm,debutpmcomp,pmcomp:pmot;
    debutpdep,pdep:pdepend;
    debutpg,pg:pecart;

Begin
        InitGrille(grille);

        ImplementCN(debutpc,grille);

        (*Creation de la liste des ecarts*)
        debutpg:=LEcarts(grille);
        pg:=debutpg;

        grilleremplie:=FALSE;
        debutpm:=LMot;

        while grilleremplie=FALSE do
        begin

                (* Determiner caracteristiques du mot a rechercher
                a l'issue de cette proc., vecmot contient le mot a rechercher*)


                DeterSpecs(pg^.x,pg^.y,pg^.l,pg^.o,grille,vecmot);

                (*Liste des mots compatibles --> pmcomp*)

                debutpmcomp:=MotsCompatibles(vecmot,debutpm,debutpg,pg);

                (*si aucun mot compatible alors ajouter case noire*)
                if debutpmcomp=NIL then
                begin
                        (*Ajout d'une case noire dans la liste*)
                         AjoutCN(debutpc,pg);

                        (*Remise a ' ' de toutes les cases de la grille*)
                        InitGrille(grille);

                        (*Implementation de la nouvelle liste de cases noires*)
                        ImplementCN(debutpc,grille);

                        (*Creation d'une nouvelle liste d'ecarts*)

                        debutpg:=LEcarts(grille);
                        pg:=debutpg;
                end
                else
                begin
                        (*reinitialisation du compteur du nombre de dependances maximum*)


                        motdepmax.ndep:=0;
                        motdepmax.ndepexis:=0;

                        (*creation de la liste de mots dependants*)

                        debutpdep:=LInter(pg^.o,pg^.l,pg);

                        (*on complete la liste des intersections*)
                        CompletLInter(motdep.ndepexis,debutpdep,debutpg,pg);

                        (*chaque mot compatible est mis dans une grille provisoire afin
                        de calculer le nombre de dependances existantes*)

                        (*initialisations*)
                        InitGrille(grilleprov);
                        pmcomp:=debutpmcomp;
                        for l:=1 to 30 do
                                for c:=1 to 30 do grilleprov[l,c]:=grille[l,c];

                        compmax:=0;
                        while (pmcomp <> NIL) do
                        begin

                                (*reinitialisation du compteur de dependances existantes*)
                                motdep.mot:=pmcomp^.mot;
                                motdep.defin:=pmcomp^.defin;
                                motdep.ndep:=0;

                                (*chaque mot compatible est d'abord mis dans une grille
                                provisoire*)
                                DansGrille(grilleprov,pg^.y,pg^.x,pg^.l,pmcomp^.mot,pg^.o);

                                (*on verifie l'existance des dependances pour chaque mot
                                ainsi mis*)
                                if debutpdep <> NIL then
                                begin
                                        pdep:=debutpdep;

                                        (*Determiner les specification pour chaque
                                        intersection*)
                                        while pdep <> NIL do
                                        begin
                                                DeterSpecs(pdep^.x,pdep^.y,pdep^.l,pdep^.o,grilleprov,pdep^.vmot);
                                                pdep:=pdep^.suiv;
                                        end;

                                        (*on comptabilise le nombre d'intersections existantes,
                                        le mot dont toutes les intersections existent sera
                                        implemente dans la grille*)
                                        InterExist(motdep.ndep,debutpm,debutpdep,pmcomp,debutpg);


                                        if motdep.ndep >= motdepmax.ndep then
                                        begin
                                                motdepmax.ndep:=motdep.ndep;
                                                motdepmax.mot:=motdep.mot;
                                                motdepmax.defin:=motdep.defin;
                                                motdepmax.ndepexis:=motdep.ndepexis;
                                        end;

                                        (*si toutes les dependences existent--> instruction qui
                                        permet de ne pas verifier d'autres mots compatibles*)
                                        if motdepmax.ndep = motdepmax.ndepexis then break;

                                end;
                                pmcomp:=pmcomp^.suiv;
                                inc(compmax);
                                if compmax=10 then break;
                        end;

                        (*Mettre le mot dans la grille*)

                        DansGrille(grille,pg^.y,pg^.x,pg^.l,motdepmax.mot,pg^.o);

                        (*Mettre le mot dans la liste*)
                        pg^.mot:=motdepmax.mot;
                        pg^.defin:=motdepmax.defin;
                        pg:=pg^.suiv;
                end;

                (*Condition Sortie*)
                Grilleremplie:=ConditionSortie(debutpg);
        end;
        CreaFSortie(debutpg);
End;







(*-------------------------------------------------------------------------*)
(*Ajouter un mot+definition dans le dictionnaire                           *)
(*-------------------------------------------------------------------------*)
Procedure AjoutMot(var dico:text);
Var nouvomot,mot,nouveldefinition,reponse:string;
Begin
        writeln('Voulez-vous entrer un nouveau mot? (oui/non)');
        readln(reponse);
        if upcase(reponse)='OUI' then
        begin
                clrscr;
                write('Veuillez entrer un mot ');
                writeln('en lettres minuscules et sans accent');
                readln(nouvomot);
                if not eof(dico) then
                begin
                    while not eof(dico) do
                    begin
                        readln(dico,mot);
                        if mot=nouvomot then
                        begin
                            writeln('***ERREUR***');
                            write('Le mot ',nouvomot,' existe dj ');
                            writeln('dans le dictionnaire');
                            writeln('Veuillez ressayer');
                            reset (dico);
                            AjoutMot(dico);

                            exit;
                        end;
                    end;
                end;
                close(dico);
                assign(dico,'dictionnaire.dat');
                append(dico);       (*va au dernier element de dico*)
                writeln(dico,nouvomot);
                writeln('Veuillez entrer la definition de ''',nouvomot,'''');
                readln(nouveldefinition);
                writeln(dico,nouveldefinition);
                close(dico);
                assign(dico,'dictionnaire.dat');
                reset(dico);
                clrscr;
                AjoutMot(dico);
        end
        else if upcase(reponse)='NON' then
               if eof(dico) then halt else exit
        else (*si reponse ni 'oui' ni 'non'*)
        begin
                clrscr;
                writeln('***ERREUR***');
                writeln('Rponse incorrecte');
                writeln('Veuillez entrer oui ou non');
                AjoutMot(dico);
        end;
end;



(*==================PROCEDURE MENU=====================================*)
PROCEDURE menu(var choix:integer);
begin
 gotoxy(1,8);
 textcolor(1);textBackground(7);
 write('');
 textcolor(7);textBackground(1);
 write('  BRASSEUR Jordan  DEQUEVY Nicolas  FOURNEL Michel  ILIC Nenad ');
 textcolor(1);textBackground(7);
 write('');
  gotoxy(1,10);
 writeln('               ');
 writeln('           ');
 writeln('                           ');
 writeln('                     ');
 writeln('                  ');
 writeln('           ');
 writeln('            ');
 gotoxy(1,21);
 writeln(' 0. JOUER UNE GRILLE');
 writeln;
 writeln(' 1. CREER UNE NOUVELLE GRILLE MANUELLEMENT');
 writeln;
 writeln(' 2. GENERER AUTOMATIQUEMENT UNE NOUVELLE GRILLE');
 writeln;
 writeln(' 3. CHARGER UNE GRILLE EXISTANTE');
 writeln;
 writeln(' 4. SAUVEGARDER UNE GRILLE');
 writeln;
 writeln(' 5. DICTIONNAIRE: AJOUT MOT / VERIF DOUBLONS');
 writeln;
 writeln(' 6. QUITTER CROSSWORDS');
 gotoxy(40,35);
 write('VOTRE CHOIX: ');
 readln(choix);
 if i=1 then exit;
end;
(*=====================================================================*)

(*====================PROCEDURE MOTUS==================================*)
(*on stock les lettres et leurs emplacements ds le mot inconnu*)
procedure motus;
var i,pos:integer;
    deuxiempasse:boolean;
 begin
  deuxiempasse:=false;
  pos:=colonnemax+6;
  gotoxy(pos,30);
  write('ex:  bo*jo*r  bonjour ');
  gotoxy(pos,31);
  write('');
  gotoxy(pos,32);
  write('Je cherche:            ');
  gotoxy(pos,33);
  write('                       ');
  gotoxy(pos,34);
  write('');
  gotoxy(pos,33);
  readln;readln(motlut);
  nbremotecrit:=0;
  longueurmot:= length (motlut);
    i:=1;
     while i<longueurmot+1 do (*on parcourt l entierete du mot*)
       begin
         if i=1 then    (*stock le premier pointeur*)
            begin
                new(pmotus);
                debutmotus:=pmotus;
                   if motlut[i]<>'*' then (* si * on ne stock pas dans la liste*)
                      begin    (*sinon on stock la lettre et sa position dans le mot*)
                         pmotus^.lettre:=motlut[i];
                         pmotus^.emplacementlettre:=i;
                         pmotus^.suivant:=nil;
                         i:=i+1;
                       end
                     else
                     begin
                      i:=i+1;
                      deuxiempasse:=true; (*on indique qu on a pas implemente le premier pointeur*)
                     end;                 (*il faudra un deuxieme passage pour l implementer*)
             end
         else
            begin
               if motlut[i]<>'*' then
                        begin
                         if deuxiempasse=false then  (*si on a implemente le premier pointeur alors on en cree un nouveau*)
                          begin
                             new (pmotus^.suivant);
                             pmotus:=pmotus^.suivant;
                          end;
                          pmotus^.lettre:=motlut[i];
                          pmotus^.emplacementlettre:=i;
                          pmotus^.suivant:=nil;
                          i:=i+1;
                          deuxiempasse:=false;

                        end
                    else
                        i:=i+1;

            end;
      end;
 end;
(*=====================================================================*)

(*=========================PROCEDURE IF_THEN1==========================*)
procedure if_then1 (p:pointeur);
var pos:integer;

  begin
   pos:=colonnemax+6;
   if  mot[p^.emplacementlettre]=p^.lettre then //si le mot contient la lettre specifiee
     begin                                      //au bon endroit alors on teste les autres lettre sinon on sort
       if p^.suivant<> nil then if_then1 (p^.suivant) // en parcourant la liste des conditions
                           else
                         begin
                         if nbremotecrit<15 //ecrire max 15 mot a l ecran
                          then
                           begin
                              gotoxy(pos,30+ii_motus);
                              write('                       ');
                              gotoxy(pos,30+ii_motus);
                              writeln (mot);
                              nbremotecrit:=nbremotecrit+1;
                              inc(ii_motus);
                           end;
                         end;
     end;
  end;
(*=====================================================================*)

(*======================PROCEDURE IF_THEN==============================*)
procedure if_then (p:pointeur);
var pos:integer;
  begin
  pos:=colonnemax+6;
  gotoxy(pos,30);
  write('                       ');
  gotoxy(pos,31);
  write('                       ');
  gotoxy(pos,32);
  write('                       ');
  gotoxy(pos,33);
  write('                       ');
  gotoxy(pos,34);
  write('                       ');
   while not eof (entree) do
     begin
       read (entree,mot);
         if length (mot)= longueurmot then // on ne test que les mots de bonne longueur

             begin
             p:=debutmotus;
              if_then1(p);


              readln (entree);
            end
         else readln (entree);
     end;
  end;

(*=====================================================================*)

(*==================PROCEDURE HORLOGE==================================*)
procedure horloge(var cb_minutes_jeu:integer);
var heure,min,sec,cent:word;
    memoiremin,echeance:word;
    touche:char;
    pos:integer;
    deuxheur:boolean;
begin
pos:=colonnemax+6;
gettime(heure,min,sec,cent);    //lecture de l'heure systme
//heurededepart:=heure;
echeance:=mindebut+cb_minutes_jeu;
deuxheur:=false; // on est pas a cheval sur deux heures par defaut
//writeln('il est ',heure,':',min);
case mindebut of

   59: begin
         echeance:=9+cb_minutes_jeu;
         deuxheur:=true; //a cheval sur 2h de 59 a 50
       end;
   58: begin
         echeance:=8+cb_minutes_jeu;
         deuxheur:=true;
       end;
    57: begin
         echeance:=7+cb_minutes_jeu;
         deuxheur:=true;
       end;
   56: begin
         echeance:=6+cb_minutes_jeu;
         deuxheur:=true;
       end;
    55: begin
         echeance:=5+cb_minutes_jeu;
         deuxheur:=true;
       end;
   54: begin
         echeance:=4+cb_minutes_jeu;
         deuxheur:=true;
       end;
    53: begin
         echeance:=3+cb_minutes_jeu;
         deuxheur:=true;
       end;
   52: begin
         echeance:=2+cb_minutes_jeu;
         deuxheur:=true;
       end;
    51: begin
         echeance:=1+cb_minutes_jeu;
         deuxheur:=true;
       end;
   50: begin
         echeance:=0+cb_minutes_jeu;
         deuxheur:=true;
       end;
  end;

gotoxy(12,12);
//repeat
//gettime(heure,min,sec,cent);

// if keypressed then
//     begin
//      touche:=readkey;
//        if (touche='1') or (touche='3') then
//         begin
    gettime (heure,min,sec,cent);
        if deuxheur=false then
         begin
          if min>echeance then
            begin
               gotoxy (pos,27);
               write('                     ');
               textcolor(9);
               gotoxy (pos,27);
               write ('Tps coul! ');
               textcolor(0);
               write ('(',heure,':',min,':',sec,')');
          end
            else
             begin
                gotoxy (pos,27);
                write('                       ');
                gotoxy (pos,27);
                write ('Reste: ', (echeance-min),'min');
                write (' (',heure,':',min,':',sec,')');
             end
         end
        else if heure=heurededepart then
         begin if (min-50)>echeance then
          begin
           gotoxy (pos,27);
           write('                     ');
           textcolor(9);
           gotoxy (pos,27);
           write ('Tps coul! ');
           textcolor(0);
           write ('(',heure,':',min,':',sec,')');
          end
            else
              begin
                gotoxy (pos,27);
                write('                       ');
                gotoxy (pos,27);
                write ('Reste: ', echeance-min+50,'min');
                write (' (',heure,':',min,':',sec,')')
             end;
      end
////TON AJOUT :
          else if heure=heurededepart+1 then
          begin if (min+10)>echeance then
          begin
           gotoxy (pos,27);
           write('                     ');
           textcolor(9);
           gotoxy (pos,27);
           write ('Tps coul! ');
           textcolor(0);
           write ('(',heure,':',min,':',sec,')');
          end
            else
              begin
                gotoxy (pos,27);
                write('                       ');
                gotoxy (pos,27);
                write ('Reste: ', echeance-min-10,'min');
                write (' (',heure,':',min,':',sec,')');
             end;

    end;

          //         end;
//      end;
//until min=echeance;
//gotoxy (16,16);
//gettime (heure,min,sec,cent);
//writeln (heure,':',min,':',sec);
end;
(*=====================================================================*)

(*==================PROCEDURE DE CREATION DE LA GRILLE=================*)
PROCEDURE creationgrille ;
var i:integer;

begin
 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 if choix=2 then begin
 write('Combien de lignes dsirez-vous? (maximum 30):' );readln(lignemax);
 gotoxy(20,40);
 write('Combien de colonnes dsirez-vous? (maximum 30):' );readln(colonnemax);
 writeln; gotoxy(20,43);
 end
 else
 begin
 write('Combien de lignes dsirez-vous? (maximum 50):' );readln(lignemax);
 gotoxy(20,40);
 write('Combien de colonnes dsirez-vous? (maximum 50):' );readln(colonnemax);
 writeln; gotoxy(20,43);
 end;
 writeln('');
  if lignemax<1 then  //verification de validite
     begin
        writeln ('mauvais choix, vous avez entr un nombre trop petit, veuillez recommencer la procedure');
        creationgrille ;  //recursivite
        exit;
     end
   else if lignemax>50 then     //verification de validite
     begin
        writeln ('mauvais choix, vous avez entr un nombre trop grand, veuillez recommencer la procedure');
        creationgrille ;  //recursivite
        exit;
    end;

   if colonnemax<1 then        //verifiaction de validite
     begin
        writeln ('mauvais choix, vous avez entr un nombre trop petit, veuillez recommencer la procedure');
        creationgrille ;
        exit;
     end
   else if colonnemax>50 then    //verification de validite
     begin
        writeln ('mauvais choix, vous avez entr un nombre trop grand, veuillez recommencer la procedure');
        creationgrille ;
        exit;
    end;
   (*else writeln ('ok, merci'); *)
 // il faut dtermniner un ratio de case noir pour avoir un program fonctionnel

 nbrecasenoir:= trunc(lignemax*colonnemax/2.5);
writeln ('vous devrez entrer minimum ',nbrecasenoir,' cases noires');
end;
(*=================================================================*)


(*=======================PROCEDURE CASENOIR========================*)
procedure casenoir (p:ptr);
var i:integer;
    coor,memoire:coordonnee;
    occurence,occurence2:boolean;

begin
if nbrecasenoir<>0 then //si pas de case noire a entrer pas de generation
begin
  writeln;
  writeln ('* CHOIX DES CASES NOIRES*');
  writeln;
  writeln ('veuillez entrer les coordonnes x,y des ', nbrecasenoir, ' cases noires, svp');
  writeln;
  writeln ('--conditions de validit des donnes--');
  writeln;
  writeln ('x doit etre compris entre 1 et', colonnemax);
  writeln ('y doit etre compris entre 1 et', lignemax);
  writeln;
 i:=1;
   if debut=nil then  //si pas de debut on en cre un. il faut memoriser le debut
         begin
            new (p);
            debut:=p;
            writeln (i, 'eme case noire');
            write ('X: ');
            read (coor.x);       // on demande d entrer un nouvel coord tant que elle respecte pas les conditions
               if (coor.x>colonnemax) or (coor.x<1)  then
                  while (coor.x>colonnemax) or (coor.x<1) do
                         begin
                           writeln ('mauvaise rponse le min en x est 1 et le max en x est ', colonnemax,' recommencez');
                           write ('X: ');
                           read (coor.x);
                         end;
            writeln ('merci');
            p^.coord.x:=coor.x;

           write ('Y: ');
           read (coor.y);         //idem
              if (coor.y>lignemax) or (coor.y<1)  then
                  while (coor.y>lignemax) or (coor.y<1) do
                          begin
                            writeln ('mauvaise rponse le min en Y est 1 et le max en Y est ',lignemax,' recommencez');
                            write ('Y: ');
                            read (coor.y);
                          end;
           writeln ('merci');
           p^.coord.y:=coor.y
          end;
 i:=2;         //on passe a la deuxieme case noire plus besoin de memoriser debut
 while i<= nbrecasenoir do
   begin
    new (p^.suivant);
    p:=p^.suivant;
    writeln (i, 'eme case noire');

    write ('X: ');
    read (coor.x);
    if (coor.x>colonnemax) or (coor.x<1)  then
     while (coor.x>colonnemax) or (coor.x<1) do
      begin
       writeln ('mauvaise rponse le min en x est 1 et le max en x est ', colonnemax,' recommencez');
        write ('X: ');
        read (coor.x);
      end;
     writeln ('merci');
     p^.coord.x:=coor.x;
     memoire.x:=coor.x;
   write ('Y: ');
    read (coor.y);
     if (coor.y>lignemax) or (coor.y<1)  then
     while (coor.y>lignemax) or (coor.y<1) do
       begin
           writeln ('mauvaise rponse le min en Y est 1 et le max en Y est ',lignemax,' recommencez');
           write ('Y: ');
           read (coor.y);
      end;
    writeln ('merci');
    p^.coord.y:=coor.y;
    memoire.y:=coor.y;
    p^.suivant:=nil;
     p:=debut ;
     occurence:=false;  //par defaut pas de doublon

      while p^.suivant<>nil do   //on verifie
       begin           // si les deux coordonnes sont les memes il y a un doublon
        if p^.coord.x = memoire.x then if p^.coord.y=memoire.y then occurence:=true;

        p:=p^.suivant;
       end;
        while occurence=true  do // tant que doublons demander une nouvelle coordonnee
          begin
           writeln ('cette coordonnee existe dja veuillez entrer de nouvelles coordones pour cette case noire');
             write ('X: ');
             read (coor.x);

               if (coor.x>colonnemax) or (coor.x<1)  then
                  while (coor.x>colonnemax) or (coor.x<1) do
                    begin
                     writeln ('mauvaise rponse le min en x est 1 et le max en x est ', colonnemax,' recommencez');
                     write ('X: ');
                     read (coor.x);
                    end;
                      writeln ('merci');
                      p^.coord.x:=coor.x;
                      memoire.x:=p^.coord.x;
            write ('Y: ');
            read (coor.y);

              if (coor.y>lignemax) or (coor.y<1)  then
                  while (coor.y>lignemax) or (coor.y<1) do
                    begin
                      writeln ('mauvaise rponse le min en Y est 1 et le max en Y est ',lignemax,' recommencez');
                      write ('Y: ');
                      read (coor.y);
                    end;
                      writeln ('merci');
                      p^.coord.y:=coor.y;
                      memoire.y:=p^.coord.y;
                      p^.suivant:=nil;

                  p:=debut;
                  occurence2:=false;
                  while p^.suivant<> nil

                   do begin
                      if (memoire.x=p^.coord.x) and (memoire.y=p^.coord.y) then occurence2:=true;
                       p:=p^.suivant;
                      end;

                   if occurence2=true then occurence:=true else occurence:=false;


          end;
  i:=i+1;
   end;

p^.suivant:=nil;

end;
end;
(*===================================================================*)



(*===================PROCEDURE TRI===================================*)
procedure tri;
 var i:integer;
       mem1,mem2:integer;
 begin
 p:=debut;

        for i:=1 to nbrecasenoir do
                begin
                    p:=debut;

                  while p^.suivant<> NIL do
                    begin

                     if p^.suivant^.coord.x < p^.coord.x then  (*tri dcroissant de longueur*)
                     begin
                      mem1:=p^.coord.x;  (*permutation*)
                      mem2:=p^.coord.y;
                      p^.coord.x:=p^.suivant^.coord.x;
                      p^.coord.y:=p^.suivant^.coord.y;
                      p^.suivant^.coord.x:=mem1;
                      p^.suivant^.coord.y:=mem2;
                     end
                     else if p^.suivant^.coord.x=p^.coord.x then

                       if p^.suivant^.coord.y<p^.coord.y then
                        begin
                          mem1:=p^.coord.x;  (*permutation*)
                          mem2:=p^.coord.y;
                          p^.coord.x:=p^.suivant^.coord.x;
                          p^.coord.y:=p^.suivant^.coord.y;
                          p^.suivant^.coord.x:=mem1;
                          p^.suivant^.coord.y:=mem2;
                        end;

                  p:=p^.suivant;
                    end;

               end;

 end;
(*======================================================================*)



(*======================PROCEDURE GENERALEA=============================*)
procedure generalea;
var i,j:integer;
     occurence,occurence2:boolean;
     memoire:coordonnee;

begin
 (*condition de fonctionnalit*)
 nbrecasenoir:= trunc(lignemax*colonnemax/2.5);  //ratio cases noires

writeln ('vous devrez entrer minimum ',nbrecasenoir,' cases noires');
 randomize; //initialisation du random
 i:=1;
if nbrecasenoir<>0 then   //si pas case noir pas de generation

begin

 new (p);
 debut:=p;

   p^.coord.x:=random(colonnemax);
    if p^.coord.x=0 then p^.coord.x:=colonnemax; //0 est interdit
   p^.coord.y:=random(lignemax);
    if p^.coord.y=0 then p^.coord.y:=lignemax;
 while i< nbrecasenoir do
  begin
   new (p^.suivant);
   p:=p^.suivant;
   p^.coord.x:=random(colonnemax);
   if p^.coord.x=0 then p^.coord.x:=colonnemax;
   memoire.x:=p^.coord.x;
   p^.coord.y:=random(lignemax);
   if p^.coord.y=0 then p^.coord.y:=lignemax;
   memoire.y:=p^.coord.y;
    p:=debut ;
     occurence:=false;


    (******************** verification des doublons***********************)

      while p^.suivant<>nil do
       begin

        if p^.coord.x = memoire.x then if p^.coord.y=memoire.y then occurence:=true;

        p:=p^.suivant;

       end;
        while occurence=true  do
          begin
           p^.coord.x:=random(colonnemax);
           if p^.coord.x=0 then  p^.coord.x:=colonnemax;
           memoire.x:=p^.coord.x;
           p^.coord.y:=random(lignemax);
           if p^.coord.y=0 then p^.coord.y:=lignemax;
           memoire.y:=p^.coord.y;

                  p:=debut;
                  occurence2:=false;
                  while p^.suivant<> nil do

                     begin
                        if (memoire.x=p^.coord.x) then if (memoire.y=p^.coord.y) then occurence2:=true;
                         p:=p^.suivant;
                     end;

                     if occurence2=true then occurence:=true else occurence:=false;
          end;
       i:=i+1;
(********************************************************************************)
  end;
p^.suivant:=nil;
(*//writeln ('*** GENERATION ALEATOIRE***');
//writeln ;
//writeln ('--le generation aleatoire a donn: ');
p:=debut;
j:=1;
//while p<>nil do
// begin
//  writeln (j,'eme case');
//  writeln ('X: ',p^.coord.x);
//  writeln ('Y: ',p^.coord.y);
//  j:=j+1;
//  p:=p^.suivant;
// end;
//readln; *)
end;
end;
(*=====================================================================*)


(*====================PROCEDURE AFFICHAGE=============================*)
PROCEDURE affichage(var nblignes,nbcolonnes:integer);
var i,j,pos:integer;
Begin
(*affichage cadre de la grille*)
clrscr;
write('   ');
for i:=1 to nbcolonnes do
 begin
  if (i=1) or (i=5) or (i=10) or (i=15) or (i=20) or (i=25) or (i=30)
     or (i=35) or (i=40) or (i=45) or (i=50) then write(i)
  else
       begin
        if (i>0) and (i<10) then write(' ');
        if (i>11) then if (i<>16) and (i<>21) and (i<>26) and (i<>31)
                                  and (i<>36) and (i<>41) and (i<>46) then write(' ');
       end;
 end;
writeln;
write('  ');
for i:=1 to nbcolonnes do write('');
writeln('');
for j:=1 to nblignes do
 begin
  if (j=1) or (j=5) or (j=10) or (j=15) or (j=20) or (j=25) or (j=30)
     or (j=35) or (j=40) or (j=45) or (j=50) then writeln(j:2,'')
  else writeln('  ');
 end;
write('  ');
for i:=1 to nbcolonnes do write('');
writeln('');

for i:=1 to nblignes do
 begin
  gotoxy(nbcolonnes+4,i+2);write('');
 end;

 (*Affichage tableau de commandes*)
pos:=nbcolonnes+5;
gotoxy(pos,3);
write(' CoordX   CoordY    Dir');
gotoxy(pos,4);
write('Ŀ  Ŀ  Ŀ');
gotoxy(pos,5);
write('                   ');
gotoxy(pos,6);
write('    ');
gotoxy(pos,8);
write(' Mot propos (espace = )');
gotoxy(pos,9);
write('Ŀ');
gotoxy(pos,10);
write('                       ');
gotoxy(pos,11);
write('');
gotoxy(pos,13);
write(' Dfinition');
gotoxy(pos,14);
write('Ŀ');
gotoxy(pos,15);
write('                       ');
gotoxy(pos,16);
write('                       ');
gotoxy(pos,17);
write('                       ');
gotoxy(pos,18);
write('                       ');
gotoxy(pos,19);
write('Maxi78caracteresĴ');
gotoxy(pos,20);
write('Findedef=.');
gotoxy(pos,22);
write(' Continuer?(3:Aide Motus)');
gotoxy(pos,23);
write('Ŀ');
gotoxy(pos,24);
write(' Non:0         1:Oui ');
gotoxy(pos,25);
write('');
gotoxy(pos,26);
write('TempsĿ');
gotoxy(pos,27);
write('                       ');
gotoxy(pos,28);
write('');
gotoxy(pos,29);
write('AideMotusĿ');
gotoxy(pos,30);
write('                       ');
gotoxy(pos,31);
write('                       ');
gotoxy(pos,32);
write('                       ');
gotoxy(pos,33);
write('                       ');
gotoxy(pos,34);
write('                       ');
gotoxy(pos,35);
write('                       ');
gotoxy(pos,36);
write('                       ');
gotoxy(pos,37);
write('                       ');
gotoxy(pos,38);
write('                       ');
gotoxy(pos,39);
write('                       ');
gotoxy(pos,40);
write('                       ');
gotoxy(pos,41);
write('                       ');
gotoxy(pos,42);
write('                       ');
gotoxy(pos,43);
write('                       ');
gotoxy(pos,44);
write('                       ');
gotoxy(pos,45);
write('');

 (*Fin Affichage tableau de commandes*)
end;
(*====================================================================*)

(*====================PROCEDURE PREND_CONTINUE_ENTREE_MOT=============*)
procedure prend_continue_entree_mot(var nbcolonnes,continue:integer);
var pos:integer;
begin
  pos:=nbcolonnes+5;
  gotoxy(pos+11,24);write('   ');gotoxy(pos+12,24);read(continue);
end;
(*====================================================================*)

(*====================PROCEDURE PREND_COORDONNEES=======================*)
Procedure prend_coordonnees(var nbcolonnes,coordX,coordY:integer;var Dir:char);
var pos:integer;
begin
  pos:=nbcolonnes+5;
  (*-------COORDONNEES------*)
  gotoxy(pos+3,5);write('  ');gotoxy(pos+3,5);read(coordX);
  gotoxy(pos+12,5);write('  ');gotoxy(pos+12,5);read(coordY);
  gotoxy(pos+21,5);write('  ');gotoxy(pos+21,5);readln;read(Dir);
  gotoxy(pos+1,15);
end;
(*================================================================*)

(*=====================PROCEDURE AFFICHE_DEFINITION=======================*)
Procedure affiche_definition(nbcolonnes,coordX,coordY:integer;dir:char;def:vecteurdef;var mat:matrice);
var i,j,k,l,n,o,u,a,ok,pos:integer;
begin
  for i:=1 to 78 do def[i]:=' ';
  if dir='v' then def:=mat[coordY,coordX].definitionv;
  if dir='h' then def:=mat[coordY,coordX].definitionh;
  pos:=nbcolonnes+5;
  gotoxy(pos+1,15);For i:= 1 to 23 do write(def[i]);
  gotoxy(pos+1,16);For i:=24 to 46 do write(def[i]);
  gotoxy(pos+1,17);For i:=47 to 59 do write(def[i]);
  gotoxy(pos+1,18);For i:=60 to 78 do write(def[i]);
end;
(*====================================================================*)

(*====================PROCEDURE PREND_DEFINITION======================*)
procedure prend_definition(var nbcolonnes:integer;var def:string);
var pos,i,j,k:integer;
    def1,def2,def3,def4:string;
    touche:char;

begin
  pos:=nbcolonnes+5;
  for i:=1 to 4 do begin gotoxy(pos+1,14+i);write('                       ');end;
  for i:=1 to 78 do def[i]:=' ';
  i:=0;j:=0;k:=0;
  repeat
  begin
  gotoxy(pos+1+i,15+j);
  if keypressed then
     begin
      touche:=readkey;
           inc(i);if k<78 then inc(k);
           def[k]:=touche;
           write(touche);
      if (i=23) or (i=46) or (i=69) then begin inc(j);i:=0;end;
      end;
  end
  until touche='.';
end;
(*====================================================================*)

(*====================PROCEDURE TRAITE_DEFINITION======================*)
procedure traite_definition(var coordX,coordY:integer;Dir:char;var def:string;var mat:matrice);
var i:integer;
    la_def:string;

begin
  for i:=1 to 78 do la_def[i]:=def[i];

  if Dir='h' then for i:=1 to 78 do mat[coordY,coordX].definitionh[i]:=def[i];
  if Dir='v' then for i:=1 to 78 do mat[coordY,coordX].definitionv[i]:=def[i];
end;
(*====================================================================*)

(*====================PROCEDURE PREND_MOTPROPOSE======================*)
Procedure prend_motpropose(var nbcolonnes(*,coordX,coordY*):integer;var motpropose:string);
var pos:integer;
begin
  pos:=nbcolonnes+5;
  gotoxy(pos+1,10);read;read(motpropose);
end;
(*====================================================================*)

(*===================PROCEDURE TRAITE_MOTPROPOSE======================*)
Procedure traite_motpropose(var coordX,coordY:integer; var Dir:char;var motpropose:string;var m:matrice);
type mot_aux2=array[1..27] of char;
var mot_aux:mot_aux2;
    i,lg:integer;
begin
  mot_aux:=motpropose;
  lg:=length(motpropose);
  for i:=lg+1 to 26 do mot_aux[i]:=' ';

  if Dir='h' then
  begin
   For i:=0 to lg-1 do
   begin
    m[coordY,coordX+i].lettre:=mot_aux[i+1];
   end;
  end;

  if Dir='v' then
  begin
   For i:=0 to lg-1 do
   begin
    m[coordY+i,coordX].lettre:=mot_aux[i+1];
   end;
  end;
end;
(*====================================================================*)

(*===================PROCEDURE AFFICHE_CONTENU========================*)
 PROCEDURE affiche_contenu(var nblignes,nbcolonnes:integer;var m:matrice;var debut,p:ptr);
 var i,j,pos:integer;
 begin
 (*Affichage contenu de la grille*)
  (*Affichage des cases noires: *)
 if (choix=1) and (reponse=0) then
 begin
  readln;
  p:=debut;
  p:=p^.suivant;
     while p<> nil do
         begin
            m[p^.coord.y,p^.coord.x].lettre:='';
            p:=p^.suivant;
         end;
  end;
  (*fin affichage des cases noires*)

gotoxy(4,3);
for i:=1 to nblignes do
 begin
  for j:=1 to nbcolonnes do
   begin
    if m[i,j].lettre='' then textcolor(0) else textcolor(1);
    write(m[i,j].lettre);

   end;
  gotoxy(4,3+i);
 end;
end;
 (*Fin Affichage contenu de la grille*)
(*===================================================================*)

(*====================PROCEDURE FLUOMOT==============================*)
Procedure fluomot(var nbcolonnes,nblignes:integer;var coordX,coordY:integer;var Dir:char;var m:matrice);
var ok:boolean;
    pos,x,y:integer;
begin
  x:=coordX;y:=coordY;
  pos:=nbcolonnes+5;
  gotoxy(pos+1,10);
  write('                           ');
  If (Dir='v') OR (Dir='V') then (*Dir=1=horizontal, Dir=2=vertical*)
  begin
     ok:=true;
     while ok=true do
     begin
      if (m[coordY,coordX].lettre='') OR (nblignes+1=coordY) then ok:=false else
       begin
        (*Affiche ds 'mot propos'*)
        inc(pos);
        gotoxy(pos,10);
        write(m[coordY,coordX].lettre);
        (*fin*)
        inc(coordY);
        gotoxy(coordX+3,coordY+1);
        textbackground(11);
        write(m[coordY-1,coordX].lettre);
        textbackground(7);
       end;
     end;
   end;
   If (Dir='h') OR (Dir='H') then
   begin
     ok:=true;
     while ok=true do
     begin
      if (m[coordY,coordX].lettre='') OR (nbcolonnes+1=coordX) then ok:=false else
       begin
        (*Affiche ds 'mot propos'*)
        inc(pos);
        gotoxy(pos,10);
        write(m[coordY,coordX].lettre);
        (*fin*)
        inc(coordX);
        gotoxy(coordX+2,coordY+2);
        textbackground(11);
        write(m[coordY,coordX-1].lettre);
        textbackground(7);
       end;
     end;
   end;
   coordX:=x;coordY:=y;
end;
(*===================================================================*)

(*====================PROCEDURE SAUVE_GRILLE=========================*)
procedure sauve_grille(nblignes,nbcolonnes:integer;var mat:matrice; kelfichier:integer);
var i,j,k,g:integer;
    save0:text;
begin
if kelfichier=1 then assign(save0,'save1.dat');
if kelfichier=2 then assign(save0,'save2.dat');
if kelfichier=3 then assign(save0,'save3.dat');
if kelfichier=4 then assign(save0,'save4.dat');
if kelfichier=5 then assign(save0,'save5.dat');
rewrite(save0);
writeln(save0,nblignes,' ',nbcolonnes);
for i:=1 to nblignes do for j:=1 to nbcolonnes do
 begin

  if mat[i,j].lettre <> '' then
   begin
(*1.: Sauvegarde de tous les mots verticaux ayant plus d'une lettre*)
    if i<>1 then
(*1.1: idem mais pour les mots qui ne commencent pas sur la 1ere ligne de la grille*)
     begin
      if (mat[i-1,j].lettre='') and ((mat[i+1,j].lettre<>'') and (i<>nblignes))
        then
          begin
           write(save0,j,' ',i,' v ');
           k:=i;
           while (mat[k,j].lettre<>'') and (k-1<>nblignes) do
            begin
             write(save0,mat[k,j].lettre);
             inc(k);
            end;
           write(save0,' ');
           for g:=1 to 78 do write(save0,mat[i,j].definitionv[g]);
           writeln(save0);
          end
     end
     else
(*1.2.: idem mais pour les mots commenant sur la 1ere ligne de la grille*)
      begin
       if (mat[i+1,j].lettre<>'') and (i<>nblignes)
        then
          begin
           write(save0,j,' ',i,' v ');
           k:=i;
           while (mat[k,j].lettre<>'') and (k-1<>nblignes) do
            begin
             write(save0,mat[k,j].lettre);
             inc(k);
            end;
           write(save0,' ');
           for g:=1 to 78 do write(save0,mat[i,j].definitionv[g]);
           writeln(save0);
          end
      end;



(*2.: Sauvegarde de tous les mots horizontaux ayant plus d'une lettre*)
    if j<>1 then
(*1.1: idem mais pour les mots qui ne commencent pas sur la 1ere colonne de la grille*)
     begin
      if (mat[i,j-1].lettre='') and ((mat[i,j+1].lettre<>'') and (j<>nbcolonnes))
        then
          begin
           write(save0,j,' ',i,' h ');
           k:=j;
           while (mat[i,k].lettre<>'') and (k-1<>nbcolonnes) do
            begin
             write(save0,mat[i,k].lettre);
             inc(k);
            end;
           write(save0,' ');
           for g:=1 to 78 do write(save0,mat[i,j].definitionh[g]);
           writeln(save0);
          end
     end
     else
(*1.2.: idem mais pour les mots commenant sur la 1ere colonne de la grille*)
      begin
       if (mat[i,j+1].lettre<>'') and (j<>nbcolonnes)
        then
          begin
           write(save0,j,' ',i,' h ');
           k:=j;
           while (mat[i,k].lettre<>'') and (k-1<>nbcolonnes) do
            begin
             write(save0,mat[i,k].lettre);
             inc(k);
            end;
           write(save0,' ');
           for g:=1 to 78 do write(save0,mat[i,j].definitionh[g]);
           writeln(save0);
          end
      end;
     end;
 end;
close(save0);
end;
(*===================================================================*)

(*==============PROCEDURE CHARGE_GRILLE==============================*)
Procedure charge_grille(var lignemax,colonnemax:integer;var mat:matrice;kelfichier:integer(*;var def:vecteurdef*));
var i,j,k:integer;
    espace,direction,c:char;
    save0:text;
    def_aux:string;
begin
if kelfichier=1 then assign(save0,'save1.dat');
if kelfichier=2 then assign(save0,'save2.dat');
if kelfichier=3 then assign(save0,'save3.dat');
if kelfichier=4 then assign(save0,'save4.dat');
if kelfichier=5 then assign(save0,'save5.dat');
reset(save0);
read(save0,lignemax);read(save0,espace);
readln(save0,colonnemax);
for i:=1 to lignemax do for j:=1 to colonnemax do mat[i,j].lettre:=' ';
while not eof(save0) do
begin
 read(save0,j);read(save0,espace);
 read(save0,i);read(save0,espace);
 read(save0,direction);read(save0,espace);
 read(save0,c);
 k:=0;
 while c<>' ' do
  begin
   if direction='h' then mat[i,j+k].lettre:=c;
   if direction='v' then mat[i+k,j].lettre:=c;
   read(save0,c);
   inc(k);
  end;
 read(save0,def_aux);
 if direction='h' then mat[i,j].definitionh:=def_aux;
 if direction='v' then mat[i,j].definitionv:=def_aux;
 readln(save0);
end;
close(save0);
for i:=1 to lignemax do for j:=1 to colonnemax do
 if mat[i,j].lettre=' ' then mat[i,j].lettre:='';
end;
(*===================================================================*)

(*===========PROCEDURE CHARGE_LISTE_CASES_NOIRES=============(jeu)===*)
procedure charge_liste_cases_noires(var nblignes,nbcolonnes:integer;var m,mjeu:matrice;var mdebut,mp:ptr);
var i,j,k:integer;
begin
 dispose(mdebut);dispose(mp);
 k:=1;
 for i:=1 to nblignes do for j:=1 to nbcolonnes do
 begin
  if (m[i,j].lettre='') or (m[i,j].lettre=' ') or (m[i,j].lettre='')
   then begin
         if k=1 then
          begin
           new(mdebut);
           mdebut^.coord.x:=j;
           mdebut^.coord.y:=i;
           mp:=mdebut;
           k:=0;
          end
         else
         begin
          new(mp^.suivant);
          mp:=mp^.suivant;
          mp^.coord.x:=j;
          mp^.coord.y:=i;
          //write ('X,Y: ',mp^.coord.x,mp^.coord.y);
         end
        end;
 end;
end;
(*===================================================================*)

(*===========PROCEDURE AFFICHE_LISTE_CASES_NOIRES============(jeu)===*)
procedure affiche_liste_cases_noires(var nblignes,nbcolonnes:integer;var m,mjeu:matrice;var mdebut,mp:ptr);
var i,j,    k:integer;
begin
 mp:=mdebut;
 while mp<>nil do
 begin
   //write ('2|X,Y: ',mp^.coord.x,mp^.coord.y);
   i:=mp^.coord.y;
   j:=mp^.coord.x;
   mjeu[i,j].lettre:='';
   mp:=mp^.suivant;
  end;

end;
(*===================================================================*)

(*===============PROCEDURE AFFICHE_CONTENU_CORRIGE===================*)
procedure affiche_contenu_corrige(var nblignes,nbcolonnes:integer; var m1,m2:matrice);
var i,j,sierreur:integer;
Begin


sierreur:=1;
gotoxy(4,3);
for i:=1 to nblignes do
 begin
  for j:=1 to nbcolonnes do
   begin
    if m2[i,j].lettre<>'' then
     begin
      textcolor(1);
       if m2[i,j].lettre='' then begin sierreur:=1;textcolor(0);end else
         if m2[i,j].lettre <> m1[i,j].lettre then begin textcolor(5);sierreur:=1;end
          else begin textcolor(1);sierreur:=0;end;
      write(m2[i,j].lettre);
      textcolor(1);


     end
    else
     begin
      textcolor(0);
      write('');
     end;
   end;
  gotoxy(4,3+i);
 end;
end;
(*===================================================================*)

BEGIN
textcolor(1);
textBackground(7);

while choix<>6 do
begin
clrscr;
menu(choix);
(*-----------------------choix 0-(jouer)-----------------------------*)
if choix=0 then
begin
 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 writeln('Quelle grille voulez-vous jouer? ');
 gotoxy(50,38);write('1: ''save1.dat''');
 gotoxy(50,39);write('2: ''save2.dat''');
 gotoxy(50,40);write('3: ''save3.dat''');
 gotoxy(50,41);write('4: ''save4.dat''');
 gotoxy(50,42);write('5: ''save5.dat''');
 writeln; gotoxy(20,43);
 writeln('');
 gotoxy(55,37);
 read(fichier);
 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 writeln('Combien de temps vous laissez-vous ? ');
 gotoxy(50,38);write('                                 ');
 gotoxy(50,39);write('                                 ');
 gotoxy(35,40);write('Choisissez entre 1  10 minutes  ');
 gotoxy(50,41);write('                                 ');
 gotoxy(50,42);write('                                 ');
 writeln; gotoxy(20,43);
 writeln('');
 gotoxy(57,37);
 read(minutes_pr_le_jeu);


 charge_grille(lignemax,colonnemax,m,fichier);
 readln;
 affichage(lignemax,colonnemax);
 for i:=1 to lignemax do for j:=1 to colonnemax do mjeu[i,j].lettre:='';
 charge_liste_cases_noires(lignemax,colonnemax,m,mjeu,mdebut,mp);
 affiche_liste_cases_noires(lignemax,colonnemax,m,mjeu,mdebut,mp);
 affiche_contenu(lignemax,colonnemax,mjeu,mdebut,mp);
 prend_continue_entree_mot(colonnemax,continue_entree_mot);
(* gettime(i,mindebut,i,i);*)

gettime(heure,min,sec,cent);    //lecture de l'heure systme
heurededepart:=heure;
mindebut:=min;
// horloge(minutes_pr_le_jeu);
 (*boucle-de-jeu*)
 while continue_entree_mot=1 do
 begin

  affiche_contenu_corrige(lignemax,colonnemax,m,mjeu);
  affiche_liste_cases_noires(lignemax,colonnemax,m,mjeu,mdebut,mp);
  horloge(minutes_pr_le_jeu);
  prend_coordonnees(colonnemax,coordX,coordY,Dir);
  affiche_definition(colonnemax,coordX,coordY,Dir,definition,m);
  fluomot(colonnemax,lignemax,coordX,coordY,Dir,mjeu);
  readln;
  prend_motpropose(colonnemax,motpropose);
  traite_motpropose(coordX,coordY,Dir,motpropose,mjeu);
 // horloge(minutes_pr_le_jeu);
  affiche_contenu_corrige(lignemax,colonnemax,m,mjeu);

  prend_continue_entree_mot(colonnemax,continue_entree_mot);
 // horloge(minutes_pr_le_jeu);
  /////////////////MOTUS (aide pour trouver les mots)(ex: bo*jo*r)
  while continue_entree_mot=3 do
  begin
    assign (entree,'dictionnaire.dat');
    reset (entree);
    ii_motus:=0; (*ne sert que pour l'affichage (cf.proc if_then1)*)
    motus;
    p:=debut;
    if_then(pmotus);
    prend_continue_entree_mot(colonnemax,continue_entree_mot);
    close(entree);
  end;
  /////////////////
 end;
(*fin du bloc*)


 end;
(*-------fin choix 0-------------------------------------------------*)

(*------------------choix 1-(creer sa propre grille)-----------------*)
if choix=1 then
begin
 creationgrille;

 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 writeln('Voulez-vous que Crosswords gnre pour vous    ');
 gotoxy(20,38);
 writeln('les cases noires?                              ');
 gotoxy(20,40);write('                        0: Oui                     ');
 gotoxy(20,41);write('                        1: Non                     ');
 writeln; gotoxy(20,43);
 writeln('');
 gotoxy(39,38);
 read(reponse);

   generalea;
   tri;

for i:=1 to lignemax do for j:=1 to colonnemax do m[i,j].lettre:='';

affichage(lignemax,colonnemax);
affiche_contenu(lignemax,colonnemax,m,debut,p);

 prend_continue_entree_mot(colonnemax,continue_entree_mot);
(*boucle-de-creation*)
 while continue_entree_mot=1 do
 begin
  prend_coordonnees(colonnemax,coordX,coordY,Dir);
  affiche_definition(colonnemax,coordX,coordY,Dir,definition,m);
  affiche_contenu(lignemax,colonnemax,m,debut,p);
  fluomot(colonnemax,lignemax,coordX,coordY,Dir,m);
  if reponse=1 then readln;
  prend_motpropose(colonnemax,motpropose);
  traite_motpropose(coordX,coordY,Dir,motpropose,m);
  prend_definition(colonnemax,def);
  while def[1]=' ' do prend_definition(colonnemax,def);
  traite_definition(coordX,coordY,Dir,def,m);
  affiche_contenu(lignemax,colonnemax,m,debut,p);
  prend_continue_entree_mot(colonnemax,continue_entree_mot);
   /////////////////MOTUS (aide pour trouver les mots)(ex: bo*jo*r)
  while continue_entree_mot=3 do
  begin
    assign (entree,'dictionnaire.dat');
    reset (entree);
    ii_motus:=0; (*ne sert que pour l'affichage (cf.proc if_then1)*)
    motus;
    p:=debut;
    if_then(pmotus);
    prend_continue_entree_mot(colonnemax,continue_entree_mot);
    close(entree);
  end;
  /////////////////

  end;
(*fin du bloc*)
  readln;
end;
(*-------fin choix 1--------------------------------------------------*)

(*-----------------------choix 2-(generer automatiquemnt une grille)--*)
if choix=2 then
begin
 creationgrille;
 writeln;
 writeln('0: Generation manuelle');
 write('1: Generation automatique   ');
 write('Choix: '); readln(choix);

 if choix = 1 then generalea else if choix = 0 then casenoir(p);
 tri;

 textBackground(7);textcolor(1);
        clrscr;
        writeln('GENERATION DE LA GRILLE EN COURS');
        writeln('Veuillez patienter quelques instants');

        debutpc:=debut;

        (*Procedure d'implementation automatique de la grille*)
        ImplementGrille;

        clrscr;
        writeln('GENERATION TERMINEE');
        writeln('La grille a ete sauvegardee dans "save1.dat"');
        readln;





end;
(*-------fin choix 2--------------------------------------------------*)

(*-----------------------choix 3-(charger)----------------------------*)
if choix=3 then
begin
 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 writeln('De quel fichier voulez-vous la charger? ');
 gotoxy(50,38);write('1: ''save1.dat''');
 gotoxy(50,39);write('2: ''save2.dat''');
 gotoxy(50,40);write('3: ''save3.dat''');
 gotoxy(50,41);write('4: ''save4.dat''');
 gotoxy(50,42);write('5: ''save5.dat''');
 writeln; gotoxy(20,43);
 writeln('');
 gotoxy(60,37);
 read(fichier);
 charge_grille(lignemax,colonnemax,m,fichier);
 readln;
 affichage(lignemax,colonnemax);
 affiche_contenu(lignemax,colonnemax,m,debut,p);
 reponse:=1;continue_entree_mot:=1;
(*Boucle-de-creation*)
 while continue_entree_mot=1 do
 begin
  prend_coordonnees(colonnemax,coordX,coordY,Dir);
  affiche_definition(colonnemax,coordX,coordY,Dir,definition,m);
  affiche_contenu(lignemax,colonnemax,m,debut,p);
  fluomot(colonnemax,lignemax,coordX,coordY,Dir,m);
  if reponse=1 then readln;
  prend_motpropose(colonnemax,motpropose);
  traite_motpropose(coordX,coordY,Dir,motpropose,m);
  prend_definition(colonnemax,def);
  while def[1]=' ' do prend_definition(colonnemax,def);
  traite_definition(coordX,coordY,Dir,def,m);
  affiche_contenu(lignemax,colonnemax,m,debut,p);
  prend_continue_entree_mot(colonnemax,continue_entree_mot);
   /////////////////MOTUS (aide pour trouver les mots)(ex: bo*jo*r)
  while continue_entree_mot=3 do
  begin
    assign (entree,'dictionnaire.dat');
    reset (entree);
    ii_motus:=0; (*ne sert que pour l'affichage (cf.proc if_then1)*)
    motus;
    p:=debut;
    if_then(pmotus);
    prend_continue_entree_mot(colonnemax,continue_entree_mot);
    close(entree);
  end;
  /////////////////

 end;
(*fin du bloc*)
  readln;
end;
(*-------fin choix 3--------------------------------------------------*)

(*-----------------------choix 4-(sauvegarder)------------------------*)
if choix=4 then
begin
 writeln; gotoxy(20,36);
 writeln('');
 writeln; gotoxy(20,37);
 writeln('Sur quel fichier voulez-vous sauvegarder? ');
 gotoxy(50,38);write('1: ''save1.dat''');
 gotoxy(50,39);write('2: ''save2.dat''');
 gotoxy(50,40);write('3: ''save3.dat''');
 gotoxy(50,41);write('4: ''save4.dat''');
 gotoxy(50,42);write('5: ''save5.dat''');
 writeln; gotoxy(20,43);
 writeln('');
 gotoxy(62,37);
 read(fichier);

 sauve_grille(lignemax,colonnemax,m,fichier);
 clrscr;
 gotoxy(20,20);
 write('Votre grille a t correctement sauvegarde');
 gotoxy(20,22);
 write('     sur le fichier texte ''save',fichier,'.dat''');
 readln;
end;
(*-------fin choix 4--------------------------------------------------*)

(*---------------------choix 5-(dictionnaire: ajout et verif doublon)-*)
if choix=5 then
begin
   assign(dictio,'dictionnaire.dat');
   reset(dictio);

  gotoxy(20,40);
   If DictioVide(dictio)=True then AjoutMot(dictio);
      ajoutmot(dictio);
      close(dictio);

      readln;


end;
(*-------fin choix 5--------------------------------------------------*)


(*---------------------choix 6-(quitter)------------------------------*)
if choix=6 then
begin
  gotoxy(20,40);
  write('MERCI D''AVOIR JOU A CROSSWORDS!');
end;
(*-------fin choix 5--------------------------------------------------*)

readln;
end; (*fin de la boucle while choix<>5...*)
END.
